// gpu/ipc/common/gpu_extra_info.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef GPU_IPC_COMMON_GPU_EXTRA_INFO_MOJOM_BLINK_H_
#define GPU_IPC_COMMON_GPU_EXTRA_INFO_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "gpu/ipc/common/gpu_extra_info.mojom-shared.h"
#include "gpu/ipc/common/gpu_extra_info.mojom-blink-forward.h"
#include "ui/gfx/mojom/buffer_types.mojom-blink-forward.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"




#include "third_party/blink/public/platform/web_common.h"



// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace gpu {
namespace mojom {
namespace blink {









class BLINK_PLATFORM_EXPORT ANGLEFeature {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ANGLEFeature, T>::value>;
  using DataView = ANGLEFeatureDataView;
  using Data_ = internal::ANGLEFeature_Data;

  template <typename... Args>
  static ANGLEFeaturePtr New(Args&&... args) {
    return ANGLEFeaturePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ANGLEFeaturePtr From(const U& u) {
    return mojo::TypeConverter<ANGLEFeaturePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ANGLEFeature>::Convert(*this);
  }


  ANGLEFeature();

  ANGLEFeature(
      const WTF::String& name,
      const WTF::String& category,
      const WTF::String& description,
      const WTF::String& bug,
      const WTF::String& status,
      const WTF::String& condition);

  ~ANGLEFeature();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ANGLEFeaturePtr>
  ANGLEFeaturePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ANGLEFeature::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ANGLEFeature::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ANGLEFeature::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ANGLEFeature_UnserializedMessageContext<
            UserType, ANGLEFeature::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<ANGLEFeature::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return ANGLEFeature::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ANGLEFeature_UnserializedMessageContext<
            UserType, ANGLEFeature::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ANGLEFeature::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  WTF::String name;
  
  WTF::String category;
  
  WTF::String description;
  
  WTF::String bug;
  
  WTF::String status;
  
  WTF::String condition;

  // Write this structure into |value|. The members are represented as a
  // dictionary |member name|: |member value|. This method does not deal with
  // the dictionary name. The caller is responsible for not calling
  // |AsValueInto| when |value| expects array items (see Array/Dictionary
  // methods of |base::trace_event::TracedValue|).
  //
  // |value| The TracedValue to be written into.
  //
  // Example uses:
  //
  //   // |my_var1, my_var2| are variables with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   value->BeginDictionary("my_var1");
  //   my_var1.AsValueInto(value.get());
  //   value->EndDictionary();
  //   value->BeginDictionary("my_var2");
  //   my_var2.AsValueInto(value.get());
  //   value->EndDictionary();
  //
  //   // |my_var| is a variable with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   my_var.AsValueInto(value.get());
  //   TRACE_EVENT1("test", "test", "my_var", std::move(value));
  //
  // Calling |AsValueInto| on two objects without opening and closing a
  // dictionary for each object is theoretically possible, but strongly
  // discouraged due to potential name collisions:
  //
  //   struct A {
  //     int foo;
  //   };
  //   struct B {
  //     int bar;
  //   };
  //   struct C {
  //     int foo;
  //     int bar;
  //   };
  //   auto value1 = std::make_unique<base::trace_event::TracedValue>();
  //   auto value2 = std::make_unique<base::trace_event::TracedValue>();
  //   A a;
  //   B b;
  //   C c;
  //   // value1 and value2 will be filled with the same information:
  //   a.AsValueInto(value1);
  //   b.AsValueInto(value1);
  //   c.AsValueInto(value2);
  void AsValueInto(base::trace_event::TracedValue* value) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ANGLEFeature::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ANGLEFeature::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ANGLEFeature::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ANGLEFeature::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class BLINK_PLATFORM_EXPORT GpuExtraInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<GpuExtraInfo, T>::value>;
  using DataView = GpuExtraInfoDataView;
  using Data_ = internal::GpuExtraInfo_Data;

  template <typename... Args>
  static GpuExtraInfoPtr New(Args&&... args) {
    return GpuExtraInfoPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static GpuExtraInfoPtr From(const U& u) {
    return mojo::TypeConverter<GpuExtraInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, GpuExtraInfo>::Convert(*this);
  }


  GpuExtraInfo();

  explicit GpuExtraInfo(
      WTF::Vector<ANGLEFeaturePtr> angle_features);

  ~GpuExtraInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = GpuExtraInfoPtr>
  GpuExtraInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, GpuExtraInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        GpuExtraInfo::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        GpuExtraInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::GpuExtraInfo_UnserializedMessageContext<
            UserType, GpuExtraInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<GpuExtraInfo::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return GpuExtraInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::GpuExtraInfo_UnserializedMessageContext<
            UserType, GpuExtraInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<GpuExtraInfo::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  WTF::Vector<ANGLEFeaturePtr> angle_features;

  // Write this structure into |value|. The members are represented as a
  // dictionary |member name|: |member value|. This method does not deal with
  // the dictionary name. The caller is responsible for not calling
  // |AsValueInto| when |value| expects array items (see Array/Dictionary
  // methods of |base::trace_event::TracedValue|).
  //
  // |value| The TracedValue to be written into.
  //
  // Example uses:
  //
  //   // |my_var1, my_var2| are variables with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   value->BeginDictionary("my_var1");
  //   my_var1.AsValueInto(value.get());
  //   value->EndDictionary();
  //   value->BeginDictionary("my_var2");
  //   my_var2.AsValueInto(value.get());
  //   value->EndDictionary();
  //
  //   // |my_var| is a variable with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   my_var.AsValueInto(value.get());
  //   TRACE_EVENT1("test", "test", "my_var", std::move(value));
  //
  // Calling |AsValueInto| on two objects without opening and closing a
  // dictionary for each object is theoretically possible, but strongly
  // discouraged due to potential name collisions:
  //
  //   struct A {
  //     int foo;
  //   };
  //   struct B {
  //     int bar;
  //   };
  //   struct C {
  //     int foo;
  //     int bar;
  //   };
  //   auto value1 = std::make_unique<base::trace_event::TracedValue>();
  //   auto value2 = std::make_unique<base::trace_event::TracedValue>();
  //   A a;
  //   B b;
  //   C c;
  //   // value1 and value2 will be filled with the same information:
  //   a.AsValueInto(value1);
  //   b.AsValueInto(value1);
  //   c.AsValueInto(value2);
  void AsValueInto(base::trace_event::TracedValue* value) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(GpuExtraInfo);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, GpuExtraInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, GpuExtraInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, GpuExtraInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, GpuExtraInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
ANGLEFeaturePtr ANGLEFeature::Clone() const {
  return New(
      mojo::Clone(name),
      mojo::Clone(category),
      mojo::Clone(description),
      mojo::Clone(bug),
      mojo::Clone(status),
      mojo::Clone(condition)
  );
}

template <typename T, ANGLEFeature::EnableIfSame<T>*>
bool ANGLEFeature::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  if (!mojo::Equals(this->category, other_struct.category))
    return false;
  if (!mojo::Equals(this->description, other_struct.description))
    return false;
  if (!mojo::Equals(this->bug, other_struct.bug))
    return false;
  if (!mojo::Equals(this->status, other_struct.status))
    return false;
  if (!mojo::Equals(this->condition, other_struct.condition))
    return false;
  return true;
}

template <typename T, ANGLEFeature::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<>{}(lhs.name, rhs.name))
    return true;
  if (std::less<>{}(rhs.name, lhs.name))
    return false;
  if (std::less<>{}(lhs.category, rhs.category))
    return true;
  if (std::less<>{}(rhs.category, lhs.category))
    return false;
  if (std::less<>{}(lhs.description, rhs.description))
    return true;
  if (std::less<>{}(rhs.description, lhs.description))
    return false;
  if (std::less<>{}(lhs.bug, rhs.bug))
    return true;
  if (std::less<>{}(rhs.bug, lhs.bug))
    return false;
  if (std::less<>{}(lhs.status, rhs.status))
    return true;
  if (std::less<>{}(rhs.status, lhs.status))
    return false;
  if (std::less<>{}(lhs.condition, rhs.condition))
    return true;
  if (std::less<>{}(rhs.condition, lhs.condition))
    return false;
  return false;
}
template <typename StructPtrType>
GpuExtraInfoPtr GpuExtraInfo::Clone() const {
  return New(
      mojo::Clone(angle_features)
  );
}

template <typename T, GpuExtraInfo::EnableIfSame<T>*>
bool GpuExtraInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->angle_features, other_struct.angle_features))
    return false;
  return true;
}

template <typename T, GpuExtraInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<>{}(lhs.angle_features, rhs.angle_features))
    return true;
  if (std::less<>{}(rhs.angle_features, lhs.angle_features))
    return false;
  return false;
}


}  // namespace blink
}  // namespace mojom
}  // namespace gpu

namespace mojo {


template <>
struct BLINK_PLATFORM_EXPORT StructTraits<::gpu::mojom::blink::ANGLEFeature::DataView,
                                         ::gpu::mojom::blink::ANGLEFeaturePtr> {
  static bool IsNull(const ::gpu::mojom::blink::ANGLEFeaturePtr& input) { return !input; }
  static void SetToNull(::gpu::mojom::blink::ANGLEFeaturePtr* output) { output->reset(); }

  static const decltype(::gpu::mojom::blink::ANGLEFeature::name)& name(
      const ::gpu::mojom::blink::ANGLEFeaturePtr& input) {
    return input->name;
  }

  static const decltype(::gpu::mojom::blink::ANGLEFeature::category)& category(
      const ::gpu::mojom::blink::ANGLEFeaturePtr& input) {
    return input->category;
  }

  static const decltype(::gpu::mojom::blink::ANGLEFeature::description)& description(
      const ::gpu::mojom::blink::ANGLEFeaturePtr& input) {
    return input->description;
  }

  static const decltype(::gpu::mojom::blink::ANGLEFeature::bug)& bug(
      const ::gpu::mojom::blink::ANGLEFeaturePtr& input) {
    return input->bug;
  }

  static const decltype(::gpu::mojom::blink::ANGLEFeature::status)& status(
      const ::gpu::mojom::blink::ANGLEFeaturePtr& input) {
    return input->status;
  }

  static const decltype(::gpu::mojom::blink::ANGLEFeature::condition)& condition(
      const ::gpu::mojom::blink::ANGLEFeaturePtr& input) {
    return input->condition;
  }

  static bool Read(::gpu::mojom::blink::ANGLEFeature::DataView input, ::gpu::mojom::blink::ANGLEFeaturePtr* output);
};


template <>
struct BLINK_PLATFORM_EXPORT StructTraits<::gpu::mojom::blink::GpuExtraInfo::DataView,
                                         ::gpu::mojom::blink::GpuExtraInfoPtr> {
  static bool IsNull(const ::gpu::mojom::blink::GpuExtraInfoPtr& input) { return !input; }
  static void SetToNull(::gpu::mojom::blink::GpuExtraInfoPtr* output) { output->reset(); }

  static const decltype(::gpu::mojom::blink::GpuExtraInfo::angle_features)& angle_features(
      const ::gpu::mojom::blink::GpuExtraInfoPtr& input) {
    return input->angle_features;
  }

  static bool Read(::gpu::mojom::blink::GpuExtraInfo::DataView input, ::gpu::mojom::blink::GpuExtraInfoPtr* output);
};

}  // namespace mojo

#endif  // GPU_IPC_COMMON_GPU_EXTRA_INFO_MOJOM_BLINK_H_