// third_party/blink/public/mojom/webtransport/quic_transport_connector.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBTRANSPORT_QUIC_TRANSPORT_CONNECTOR_MOJOM_BLINK_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBTRANSPORT_QUIC_TRANSPORT_CONNECTOR_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/webtransport/quic_transport_connector.mojom-shared.h"
#include "third_party/blink/public/mojom/webtransport/quic_transport_connector.mojom-blink-forward.h"
#include "services/network/public/mojom/quic_transport.mojom-blink.h"
#include "url/mojom/url.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"


#include "third_party/blink/renderer/platform/platform_export.h"



// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace blink {
namespace mojom {
namespace blink {

class QuicTransportConnectorProxy;

template <typename ImplRefTraits>
class QuicTransportConnectorStub;

class QuicTransportConnectorRequestValidator;


class PLATFORM_EXPORT QuicTransportConnector
    : public QuicTransportConnectorInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = QuicTransportConnectorInterfaceBase;
  using Proxy_ = QuicTransportConnectorProxy;

  template <typename ImplRefTraits>
  using Stub_ = QuicTransportConnectorStub<ImplRefTraits>;

  using RequestValidator_ = QuicTransportConnectorRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kConnectMinVersion = 0,
  };
  virtual ~QuicTransportConnector() {}

  
  virtual void Connect(const ::blink::KURL& url, WTF::Vector<::network::mojom::blink::QuicTransportCertificateFingerprintPtr> fingerprints, ::mojo::PendingRemote<::network::mojom::blink::QuicTransportHandshakeClient> client) = 0;
};



class PLATFORM_EXPORT QuicTransportConnectorProxy
    : public QuicTransportConnector {
 public:
  using InterfaceType = QuicTransportConnector;

  explicit QuicTransportConnectorProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void Connect(const ::blink::KURL& url, WTF::Vector<::network::mojom::blink::QuicTransportCertificateFingerprintPtr> fingerprints, ::mojo::PendingRemote<::network::mojom::blink::QuicTransportHandshakeClient> client) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class PLATFORM_EXPORT QuicTransportConnectorStubDispatch {
 public:
  static bool Accept(QuicTransportConnector* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      QuicTransportConnector* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<QuicTransportConnector>>
class QuicTransportConnectorStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  QuicTransportConnectorStub() {}
  ~QuicTransportConnectorStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return QuicTransportConnectorStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return QuicTransportConnectorStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class PLATFORM_EXPORT QuicTransportConnectorRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace blink
}  // namespace mojom
}  // namespace blink

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBTRANSPORT_QUIC_TRANSPORT_CONNECTOR_MOJOM_BLINK_H_